# -*- coding: utf-8 -*-
"""voxelmorph_test.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/16GKw44BmzB1cbFzVl39w7XPgdFtnK6IT

# Voxelmorph training experiment

I'm using a google colab because it's way faster than my PC

And I also can let it run and do stuff

And I have v4 on google drive, so...

### Dependencies
"""

# Dependencies
!pip install SimpleITK
import SimpleITK as sitk

 !pip install voxelmorph 
import os, sys

import numpy as np
import tensorflow as tf
assert tf.__version__.startswith('2.')

import voxelmorph as vxm
import neurite as ne 
import cv2

"""### Data

#### Loading

I have almost all data inside google drive. I will mount it and decompress it.
"""

from google.colab import drive
drive.mount('/content/drive')

files_path = '/content/drive/MyDrive'

data_dir = '/content/drive/MyDrive/v4/v4' # yeah I fucked up
os.listdir(data_dir)

"""I now have a folder with the data of one patient (I could do this with the data of all patients, just trying to see how this should work). I will get all of the images from one sequence, then try to get them in the format VoxelMorph needs."""

import natsort
seq_dir = data_dir + '/SyntheticData/'
images = []
arrays = []
matcher = sitk.HistogramMatchingImageFilter()
matcher.SetNumberOfHistogramLevels(1200)
matcher.SetNumberOfMatchPoints(20)
matcher.ThresholdAtMeanIntensityOn()
folders = natsort.natsorted([seq_dir+f+'/' for f in os.listdir(seq_dir) if not "index" in f])
for folder in folders[:10]:
  files =  natsort.natsorted([folder+f for f in os.listdir(folder) if 'image' in f])
  for idx, f in enumerate(files):
    print(f)
    image = sitk.ReadImage(f)
    # PREPROCESSING - mean to 0, variance to 1?
    # I think i will just create a preprocess function here
    image = sitk.Normalize(image)
    image = sitk.DiscreteGaussian(image, (1., 1., 1.))
    if idx: 
      image = matcher.Execute(image, images[0])
    images.append(image)
    array = sitk.GetArrayFromImage(image)
    arrays.append(array)



x_train_raw = np.asarray(arrays)

"""#### Preprocessing

For the model to work, we should resize to image to a size with powers of two. I would also like to try this a a two-dimensional model first. And data should be normalized between 0 and 1. So:

- Padding or resizing to 128x128
- Normalize data
"""

import cv2
output_dim = (64, 64)

x_train = np.zeros((x_train_raw.shape[0],  *output_dim))
for patient in range(x_train.shape[0]):
    x_train[patient, ...] = cv2.resize(x_train_raw[patient, 7,  ...], output_dim, interpolation=cv2.INTER_CUBIC)

from matplotlib import pyplot as plt
plt.hist(x_train[:, ...].ravel())
pass

"""
One important thing is that it's recommended to train VXM with a generator, so as to make the poor RAM survive."""

x_train.shape

# Train with a synthetic affine example
# WARN: big -> small to avoid artifacts

# WARN: check batch_size and steps_per_epoch
from itertools import cycle
fixed_cycle = cycle([idx for idx in range(x_train.shape[0]) if idx % 2 is 0])
moving_cycle = cycle([idx for idx in range(x_train.shape[0]) if not idx % 2 is 0])

def data_generator(x_train, batch_size=60):
  vol_shape = x_train.shape[1:]
  ndims = len(vol_shape)

  zero_phi = np.zeros([batch_size, *vol_shape, ndims])

  while True:
    fixed_idxs = np.asarray([next(fixed_cycle) for _ in range(batch_size)]) 
    moving_idxs = np.asarray([next(moving_cycle) for _ in range(batch_size)])
    moving_images = x_train[fixed_idxs, ..., np.newaxis]
    fixed_images = x_train[moving_idxs, ..., np.newaxis]
    inputs = [moving_images, fixed_images]
    outputs = [fixed_images, zero_phi]
    # Esto es horrible
    # import itertools.cycle as cycle

    yield (inputs, outputs)

train_generator = data_generator(x_train, 60)
in_sample, out_sample = next(train_generator)

out_sample[0].shape

in_sample, out_sample = next(train_generator)
print(in_sample[0].shape)

images = [img[0, :, :, 0] for img in in_sample + out_sample] 
titles = ['moving', 'fixed', 'moved ground-truth (fixed)', 'zeros']
ne.plot.slices(images, titles=titles, cmaps=['gray'], do_colorbars=True);

"""Ok, that looks cool. It seems like it's the "right" way to make this work."""

out_sample[1].shape

"""### Model

Now we have to build our model. We prepared some data, now we should check out if it's going to work or not.
"""

# Shape of the data:
vol_shape = (64, 64)
nb_features = [
    [32, 32, 32, 32],         # encoder features
    [32, 32, 32, 32, 32, 16]  # decoder features
]


# Now, the model:
vxm_model = vxm.networks.VxmDense(vol_shape, nb_features, int_downsize=1)

# Losses:
losses = ['mse', vxm.losses.Grad('l2').loss]
loss_weights = [1, 0.01]

# Compile:
vxm_model.compile(optimizer=tf.keras.optimizers.Adam(lr=1e-3), loss=losses, loss_weights=loss_weights)

hist = vxm_model.fit_generator(train_generator, epochs=50, steps_per_epoch=5, verbose=1) # Try using fit instead of fit_generator
# What does loss mean - 0.005? Compare with error

import matplotlib.pyplot as plt

def plot_history(hist, loss_name='loss'):
    # Simple function to plot training history.
    plt.figure()
    plt.plot(hist.epoch, hist.history[loss_name], '.-')
    plt.ylabel('loss')
    plt.xlabel('epoch')
    plt.show()

plot_history(hist)

# let's get some data
val_generator = data_generator(x_train, batch_size = 4)

val_input, _ = next(val_generator) 
val_pred = vxm_model.predict(val_input)

val_pred[1].shape



# Chessboard to visualize images

val_input, _ = next(val_generator)
val_pred = vxm_model.predict(val_input)
# visualize
images = [img[0, :, :, 0] for img in val_input + val_pred] 
titles = ['moving', 'fixed', 'moved', 'flow']
ne.plot.slices(images, titles=titles, cmaps=['gray'], do_colorbars=True);
ne.plot.flow([3*val_pred[1][0].squeeze()], width=5);

# Chessboard to visualize images

val_input, _ = next(val_generator)
val_pred = vxm_model.predict(val_input)
# visualize
images = [img[0, :, :, 0] for img in val_input + val_pred] 
titles = ['moving', 'fixed', 'moved', 'flow']
ne.plot.slices(images, titles=titles, cmaps=['gray'], do_colorbars=True);
ne.plot.flow([3*val_pred[1][0].squeeze()], width=5);



